jQuery(document).ready(function($) {
    if (typeof dhlparcel_shipping_backoffice_page_check !== 'undefined' && $('#order_grid').length === 0) {
        return;
    }

    var dhlpps_new_version = false;
    if (typeof dhlparcel_shipping_backoffice_page_check !== 'undefined') {
        // Version 1.7.7 and up
        dhlpps_new_version = true;
    }

    if (dhlpps_new_version) {
        // Add DHL actions to bulk actions
        if (Array.isArray(dhlparcel_shipping_bulk_dropdown_data) && dhlparcel_shipping_bulk_dropdown_data.length > 0) {
            $.each(dhlparcel_shipping_bulk_dropdown_data, function (key, dropdownData) {
                console.log(dropdownData);
                if (dropdownData.type === 'create') {
                    // Add subtext
                    $('#order_grid_bulk_action_dhlparcel_shipping_bulk_create_' + dropdownData.code).attr('title', dropdownData.subtext);
                    // Add data
                    $('#order_grid_bulk_action_dhlparcel_shipping_bulk_create_' + dropdownData.code).attr('data-bulk-profile-code', dropdownData.code);
                    // Add class
                    $('#order_grid_bulk_action_dhlparcel_shipping_bulk_create_' + dropdownData.code).addClass('dhlparcel_shipping_bulk_create');
                    // Remove class
                    $('#order_grid_bulk_action_dhlparcel_shipping_bulk_create_' + dropdownData.code).removeClass('js-bulk-action-submit-btn');
                } else {
                    // Add class
                    $('#order_grid_bulk_action_dhlparcel_shipping_bulk_' + dropdownData.type).addClass('dhlparcel_shipping_bulk_download');
                    // Remove class
                    $('#order_grid_bulk_action_dhlparcel_shipping_bulk_' + dropdownData.type).removeClass('js-bulk-action-submit-btn');
                }
            });
        }
    } else {
        // Add DHL actions to bulk actions
        if (Array.isArray(dhlparcel_shipping_bulk_dropdown_data) && dhlparcel_shipping_bulk_dropdown_data.length > 0) {
            $('#bulk_action_menu_order').next('ul').append('<li class="divider"></li>');
            $('#bulk_action_menu_order').next('ul').append('<li class="dropdown-header">DHL</li>');

            $.each(dhlparcel_shipping_bulk_dropdown_data, function (key, dropdownData) {
                /** @param {{icon: string, text: string, type: string, code: string}} Obj dropdownData */
                var dhlparcel_shipping_dropdown_subtext = typeof dropdownData.subtext === 'undefined' ? '' :
                  '<br/><sub>' + dropdownData.subtext + '</sub>';

                $('#bulk_action_menu_order').next('ul')
                  .append('<li><a class="dhlparcel_shipping_bulk_' + dropdownData.type + '" ' +
                    'data-bulk-profile-code="' + dropdownData.code + '" href="#">' +
                    '<i class="' + dropdownData.icon + '">' + '</i> ' +
                    dropdownData.text +
                    dhlparcel_shipping_dropdown_subtext +
                    '</a></li>');
            });
        }
    }

    // Show any bulk messages
    // https://stackoverflow.com/a/41152400
    $.DHLParcel_Shipping_URLParam = function (name) {
        var results = new RegExp('[\?&]' + name + '=([^&#]*)').exec(window.location.search);
        return (results !== null) ? results[1] || 0 : false;
    };


    if ($.DHLParcel_Shipping_URLParam('dhlpps_bulk_action') === 'create') {
        // Fail message
        if ($.DHLParcel_Shipping_URLParam('dhlpps_bulk_fail') !== false &&
            $.DHLParcel_Shipping_URLParam('dhlpps_bulk_fail') !== 0 &&
            $.DHLParcel_Shipping_URLParam('dhlpps_bulk_fail') !== '0') {

            // Get cookie with error message
            var error_message = getBulkErrorMessage();

            var error_message_html = '';
            if (error_message != '') {
                error_message_html = '<a href="#" class="btn btn-danger" onclick="$(\'.dhlparcel_shipping_bulk_message_message\').toggle(); return false;">Show error details</a></span>' +
                    '<span class="dhlparcel_shipping_bulk_message_message" style="display: none; color: red;">' + error_message + '</span>';
            }

            if (dhlpps_new_version) {
                $('#order_grid div.row').first().after('<span class="dhlparcel_shipping_bulk_message_fail" style="display:block; color: red;">Failed ' +
                  $.DHLParcel_Shipping_URLParam('dhlpps_bulk_fail') +
                  ' labels</span>' + error_message_html);
            } else {
                $('#bulk_action_menu_order').closest('div.bulk-actions').after('<span class="dhlparcel_shipping_bulk_message_fail" style="display:block; color: red;">Failed ' +
                  $.DHLParcel_Shipping_URLParam('dhlpps_bulk_fail') +
                  ' labels</span>' + error_message_html);
            }
        }

        // Success message
        if ($.DHLParcel_Shipping_URLParam('dhlpps_bulk_success') !== '0') {
            if (dhlpps_new_version) {
                $('#order_grid div.row').first().after('<span class="dhlparcel_shipping_bulk_message_success" style="display:block; color: green;">' +
                  'Created ' + $.DHLParcel_Shipping_URLParam('dhlpps_bulk_success') + ' labels for order(s) ' + $.DHLParcel_Shipping_URLParam('dhlpps_bulk_ids') + '.</span> ' +
                  '<button class="btn btn-success dhlparcel_shipping_bulk_after_download" data-bulk-ids="' + $.DHLParcel_Shipping_URLParam('dhlpps_bulk_ids') + '">Download labels</button>');
            } else {
                $('#bulk_action_menu_order').closest('div.bulk-actions').after('<span class="dhlparcel_shipping_bulk_message_success" style="display:block; color: green;">' +
                  'Created ' + $.DHLParcel_Shipping_URLParam('dhlpps_bulk_success') + ' labels for order(s) ' + $.DHLParcel_Shipping_URLParam('dhlpps_bulk_ids') + '.</span> ' +
                  '<button class="btn btn-success dhlparcel_shipping_bulk_after_download" data-bulk-ids="' + $.DHLParcel_Shipping_URLParam('dhlpps_bulk_ids') + '">Download labels</button>');
            }
        }

        // Reselect orders if nothing is selected
        var check_order_ids = [];
        if (dhlpps_new_version) {
            $('#order_filter_form').find("input[name='order_orders_bulk[]']:checked").each(function () {
                check_order_ids.push($(this).val().toString());
            });
            if (check_order_ids.length === 0) {
                var order_ids = $.DHLParcel_Shipping_URLParam('dhlpps_bulk_ids').split(',');
                $("input[name='order_orders_bulk[]']").filter(function () {
                    return order_ids.includes(this.value);
                }).prop('checked', true);
                $('.js-bulk-actions-btn').prop('disabled', false);
            }

        } else {
            $(this).closest('form').find("input[name='orderBox[]']:checked").each(function () {
                check_order_ids.push($(this).val().toString());
            });
            if (check_order_ids.length === 0) {
                var order_ids = $.DHLParcel_Shipping_URLParam('dhlpps_bulk_ids').split(',');
                $("input[name='orderBox[]']").filter(function () {
                    return order_ids.includes(this.value);
                }).prop('checked', true);
            }
        }
    }

    $(document.body).on('click', '.dhlparcel_shipping_bulk_create', function(e) {
        e.preventDefault();

        var order_ids = [];
        if (dhlpps_new_version) {
            $('#order_filter_form').find("input[name='order_orders_bulk[]']:checked").each(function () {
                order_ids.push($(this).val().toString());
            });
        } else {
            $(this).closest('form').find("input[name='orderBox[]']:checked").each(function () {
                order_ids.push($(this).val().toString());
            });
        }

        if (order_ids.length === 0) {
            alert('Please select orders');
            return;
        }

        if (dhlpps_new_version) {
            if ($('#order_grid').find('.dhlparcel_shipping_bulk_message_wait').length === 0) {
                $('#order_grid div.row').first().after('<span class="dhlparcel_shipping_bulk_message_wait" style="display:block; color: darkorange;">Please wait...</span>');
            }
        } else {
            if ($(this).closest('div.bulk-actions').parent().find('.dhlparcel_shipping_bulk_message_wait').length === 0) {
                $(this).closest('div.bulk-actions').after('<span class="dhlparcel_shipping_bulk_message_wait" style="display:block; color: darkorange;">Please wait...</span>');
            }
        }

        var data = {
            'code': $(this).data('bulk-profile-code'),
            'order_ids': order_ids
        };

        $.post(dhlparcel_shipping_backoffice_ajax_bulk_create, data, function (response) {
            try {
                var fail = response.data.fail;
                var success = response.data.success;
                var error_message = response.data.error_message;
            } catch (error) {
                alert('Error');
                return;
            }

            $(document.body).trigger('dhlparcel_shipping:bulk_create_message', [success, fail, order_ids, error_message]);
        }, 'json');

    }).on('dhlparcel_shipping:bulk_create_message', function(e, success, fail, order_ids, error_message) {
        // Modified from:
        // https://stackoverflow.com/a/27970946

        var hash = {};
        var parser = document.createElement('a');
        parser.href = location.href;

        var parameters = parser.search.split(/\?|&/);
        for (var i = 0; i < parameters.length; i++) {
            if (!parameters[i]) {
                continue;
            }
            var ary = parameters[i].split('=');
            hash[ary[0]] = ary[1];
        }

        hash['dhlpps_bulk_success'] = success;
        hash['dhlpps_bulk_fail'] = fail;
        hash['dhlpps_bulk_action'] = 'create';
        hash['dhlpps_bulk_ids'] = order_ids.join(',');

        setBulkErrorMessage(error_message);

        var list = [];
        Object.keys(hash).forEach(function (key) {
            list.push(key + '=' + hash[key]);
        });

        parser.search = '?' + list.join('&');
        location.href = parser.href;

    }).on('click', '.dhlparcel_shipping_bulk_after_download', function(e) {
        e.preventDefault();

        var order_ids = $(this).data('bulk-ids').toString().split(',');

        if (dhlpps_new_version) {
            if ($('#order_grid').find('.dhlparcel_shipping_bulk_message_wait').length === 0) {
                $('#order_grid div.row').first().after('<span class="dhlparcel_shipping_bulk_message_wait" style="display:block; color: darkorange;">Please wait...</span>');
            }
        } else {
            if ($(this).parent().find('.dhlparcel_shipping_bulk_message_wait').length === 0) {
                $(this).after('<span class="dhlparcel_shipping_bulk_message_wait" style="display:block; color: darkorange;">Please wait...</span>');
            }
        }

        $(document.body).trigger('dhlparcel_shipping:bulk_request_download', [order_ids]);

    }).on('click', '.dhlparcel_shipping_bulk_download', function(e) {
        e.preventDefault();

        var order_ids = [];
        if (dhlpps_new_version) {
            $('#order_filter_form').find("input[name='order_orders_bulk[]']:checked").each(function () {
                order_ids.push($(this).val().toString());
            });
        } else {
            $(this).closest('form').find("input[name='orderBox[]']:checked").each(function () {
                order_ids.push($(this).val().toString());
            });
        }

        if (order_ids.length === 0) {
            alert('Please select orders');
            return;
        }

        if (dhlpps_new_version) {
            if ($('#order_grid').find('.dhlparcel_shipping_bulk_message_wait').length === 0) {
                $('#order_grid div.row').first().after('<span class="dhlparcel_shipping_bulk_message_wait" style="display:block; color: darkorange;">Please wait...</span>');
            }
        } else {
            if ($(this).closest('div.bulk-actions').parent().find('.dhlparcel_shipping_bulk_message_wait').length === 0) {
                $(this).closest('div.bulk-actions').after('<span class="dhlparcel_shipping_bulk_message_wait" style="display:block; color: darkorange;">Please wait...</span>');
            }
        }

        $(document.body).trigger('dhlparcel_shipping:bulk_request_download', [order_ids]);

    }).on('dhlparcel_shipping:bulk_request_download', function(e, order_ids) {
        var data = {
            'order_ids': order_ids
        };

        $.post(dhlparcel_shipping_backoffice_ajax_bulk_download, data, function (response) {
            try {
                var status = response.status;
                var url = response.data.url;
                var message = response.message;
            } catch (error) {
                alert('Error');
                return;
            }

            if (status === 'success') {
                var win = window.open(url, '_blank');
                if (win) {
                    win.focus();
                } else {
                    window.location = url;
                }
            } else {
                alert(message);
            }

            $('.dhlparcel_shipping_bulk_message_wait').remove();
        }, 'json');

    });

    function getBulkErrorMessage() {
        var error_message = '';
        var cookie_name = 'dhlpps_bulk_error_message=';
        var ca = document.cookie.split(';');

        for(var i = 0; i < ca.length; i++) {
            var c = ca[i];
            while (c.charAt(0) == ' ') {
                c = c.substring(1);
            }
            if (c.indexOf(cookie_name) == 0) {
                error_message =  c.substring(cookie_name.length, c.length);
                // Delete cookie with error message
                document.cookie = cookie_name + "; expires=Thu, 01 Jan 1970 00:00:00 UTC;";
            }
        }

        return error_message;
    }

    function setBulkErrorMessage(error_message) {
        document.cookie = "dhlpps_bulk_error_message=" + error_message;

        return error_message;
    }
});
